Subject: Re: bug#51411: NS port cleanups

From: Alan Third <[email-masked]>
Date: Tue, 26 Oct 2021 13:39:15 +0100

On Tue, Oct 26, 2021 at 07:41:31PM +0800, Po Lu via Bug reports for GNU Emacs, the Swiss army knife of text editors wrote:
> > Is there any reason to nest ns_focus? There are (according to Apple)
> > performance reasons to not save the context unless you really need to.
> 
> Right now it's used in the code that clips to the exact bounds of a
> string, if a string's overhangs are already drawn.
> 
> I couldn't find a cleaner way to do this, and that situation is rare, so
> I think the performance problems will usually be avoided.

Is this the code in ns_draw_glyph_string?

> > I mean alt as defined by GNUstep in the quote I sent you in my last
> > email. I don't think it's our job to say that GNUstep's choice of
> > defaults is wrong and therefore do something that would be unexpected
> > for a GNUstep user.
> 
> Well, on every other platform Meta is on the alt on the users' keyboard.
> Emacs in general doesn't conform to the platform expectations WRT to key
> bindings, so I think being consistent with Emacs on other platforms is
> more important here.

I think we normally accept what the system tells us is Alt, or the
nearest equivalent. In this case GNUstep tells us what it's
understanding of the nearest equivalent (option) is, and I don't see
any reason to override that.

So please remove the changes to modifier keys.
-- 
Alan Third